-------     =================================================================
------------  solution with mutual exclusion semaphore
-------     =================================================================


   package body Semaphores is
		-- initialisation protocol
		Mutex : Semaphore;
	
		procedure Enter(Requestor : in Global.Process_Id) is 
		begin 
			P(Mutex); 
		end Enter;
	
		procedure Quit(Requestor : in Global.Process_Id) is 
		begin 
			V(Mutex); 
		end Quit;
	
   begin
    -- initialisation protocol continued if necessary
	Initialize(Mutex, 1);
   end Semaphores;
